Option Explicit On
Imports System.Runtime.InteropServices
Module UsbC
    '****************************************************************************************************************
    '
    '   MPL-37-01v1.00/USBW64 Dynamic Link Library Structure, Function Declarations             5.3701.12.1310
    '
    '****************************************************************************************************************

    '*** DEFINITION ***
    Public Const MC07_USB_UNIT_0 As Short = &H2000
    Public Const MC07_USB_UNIT_1 As Short = &H2001
    Public Const MC07_USB_UNIT_2 As Short = &H2002
    Public Const MC07_USB_UNIT_3 As Short = &H2003
    Public Const MC07_USB_UNIT_4 As Short = &H2004
    Public Const MC07_USB_UNIT_5 As Short = &H2005
    Public Const MC07_USB_UNIT_6 As Short = &H2006
    Public Const MC07_USB_UNIT_7 As Short = &H2007
    Public Const MC07_USB_UNIT_8 As Short = &H2008
    Public Const MC07_USB_UNIT_9 As Short = &H2009

    Public Const MC07_X As Short = 0
    Public Const MC07_Y As Short = 1
    Public Const MC07_Z As Short = 2
    Public Const MC07_A As Short = 3

    Public Const MC07_EX_UNIT_COMM_RATE_5 As Short = 2

    Public Const MC07_EX_UNIT_COMM_16BIT As Short = 0
    Public Const MC07_EX_UNIT_COMM_32BIT As Short = 1

    Public Const MC07_EX_UNIT_COMM_START As Short = 0
    Public Const MC07_EX_UNIT_COMM_STOP As Short = 1
    Public Const MC07_EX_UNIT_COMM_DISC_LATCH_CLR As Short = 2

    Public Const MC07_STATUS1 As Short = 0
    Public Const MC07_STATUS2 As Short = 1
    Public Const MC07_STATUS3 As Short = 2
    Public Const MC07_STATUS4 As Short = 3
    Public Const MC07_STATUS5 As Short = 4
    Public Const MC07_ORG_STATUS As Short = 5

    Public Const MC07_GP_IN As Short = &H0
    Public Const MC07_GP_OUT As Short = &H1
    Public Const MC07_EXP0_IN As Short = &H2
    Public Const MC07_EXP1_IN As Short = &H3
    Public Const MC07_EXP0_OUT As Short = &H4
    Public Const MC07_EXP1_OUT As Short = &H5
    Public Const MC07_CTLP0_IN As Short = &H6
    Public Const MC07_CTLP0_OUT As Short = &H7

    Public Const MC07_ORG0 As Short = 0
    Public Const MC07_ORG1 As Short = 1
    Public Const MC07_ORG2 As Short = 2
    Public Const MC07_ORG3 As Short = 3
    Public Const MC07_ORG4 As Short = 4
    Public Const MC07_ORG5 As Short = 5
    Public Const MC07_ORG10 As Short = 10
    Public Const MC07_ORG11 As Short = 11
    Public Const MC07_ORG12 As Short = 12

    Public Const MC07_CCW As Short = 0
    Public Const MC07_CW As Short = 1

    Public Const MC07_SEL_X As Integer = &H1
    Public Const MC07_SEL_Y As Integer = &H2
    Public Const MC07_SEL_Z As Integer = &H4
    Public Const MC07_SEL_A As Integer = &H8
    Public Const MC07_SEL_X_Y As Integer = &H3
    Public Const MC07_SEL_X_Z As Integer = &H5
    Public Const MC07_SEL_X_A As Integer = &H9
    Public Const MC07_SEL_Y_Z As Integer = &H6
    Public Const MC07_SEL_Y_A As Integer = &HA
    Public Const MC07_SEL_Z_A As Integer = &HC
    Public Const MC07_SEL_X_Y_Z As Integer = &H7
    Public Const MC07_SEL_X_Y_A As Integer = &HB
    Public Const MC07_SEL_X_Z_A As Integer = &HD
    Public Const MC07_SEL_Y_Z_A As Integer = &HE
    Public Const MC07_SEL_X_Y_Z_A As Integer = &HF

    Public Const MC07_SEL_GP_OUT As Integer = &H1
    Public Const MC07_SEL_EXP0_OUT As Integer = &H4
    Public Const MC07_SEL_EXP1_OUT As Integer = &H8
    Public Const MC07_SEL_CTLP0_OUT As Integer = &H2
    Public Const MC07_SEL_EXP0_EXP1_OUT As Integer = &HC

    Public Const MC07_SEL_GP_IN As Integer = &H10000
    Public Const MC07_SEL_EXP0_IN As Integer = &H40000
    Public Const MC07_SEL_EXP1_IN As Integer = &H80000
    Public Const MC07_SEL_CTLP0_IN As Integer = &H20000
    Public Const MC07_SEL_EXP0_EXP1_IN As Integer = &HC0000

    '*** RESULT STRUCTURE ***
    Structure MC07_S_RESULT
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public MC07_Result() As Short
        Public Sub Initialize()
            ReDim MC07_Result(3)
        End Sub
    End Structure

    '*** COMMAND DATA STRUCTURE ***
    Structure MC07_S_COMMAND_DATA
        Public Command As Short
        Public Data As Integer
    End Structure

    '*** STATUS DATA STRUCTURE ***
    Structure MC07_S_STATUS_DATA
        Public Status1 As Short
        Public Data As Integer
    End Structure

    '*** UNIT INFO STRUCTURE ***
    Structure MC07_S_UNIT_INFO
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=10)> Public UnitType() As Short
        Public Sub Initialize()
            ReDim UnitType(9)
        End Sub
    End Structure

    '*** COMMAND BUFFER STRUCTURE ***
    Structure MC07_S_COMMAND_BUF
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Command() As Short
        Public Sub Initialize()
            ReDim Command(15)
        End Sub
    End Structure

    '*** DATA BUFFER STRUCTURE ***
    Structure MC07_S_DATA_BUF
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Data() As Integer
        Public Sub Initialize()
            ReDim Data(15)
        End Sub
    End Structure

    '*** STATUS BUFFER STRUCTURE ***
    Structure MC07_S_STATUS_BUF
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Status() As Short
        Public Sub Initialize()
            ReDim Status(15)
        End Sub
    End Structure

    '*** DATA STRUCTURE ***
    Structure MC07_S_DATA
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> Public MC07_Data() As Short
        Public Sub Initialize()
            ReDim MC07_Data(3)
        End Sub
    End Structure

    '*** SPEEDARATE SETUP STRUCTURE ***
    Structure MC07_S_SPEED_RATE
        Public FSpd As Integer
        Public HighSpeed As Integer
        Public LowSpeed As Integer
        Public EndLowSpeed As Integer
        Public SUArea As Integer
        Public SDArea As Integer
        Public URateNo As Integer
        Public DRateNo As Integer
    End Structure

    '*** X/Y POSITION STRUCTURE ***
    Structure MC07_S_XY_POSITION
        Public X As Integer
        Public Y As Integer
    End Structure

    '*** MPL ORIGIN DRIVE PARAMETER STRUCTURE ***
    Structure MC07_S_ORG_PARAM
        Public Spec As Integer
        Public MarginPulse As Integer
        Public LimitDelay As Integer
        Public ScanDelay As Integer
        Public PulseDelay As Integer
        Public CScanErrorPulse As Integer
        Public PulseErrorPulse As Integer
        Public OffsetPulse As Integer
        Public PresetPulse As Integer
    End Structure

    '*** A/D DATA STRUCTURE ***
    Structure MC07_S_AD_DATA
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> Public Data() As Short
        Public Sub Initialize()
            ReDim Data(15)
        End Sub
    End Structure

    '*** IN PORT STRUCTURE ***
    Structure MC07_S_IN_PORT
        Public Gpin As Short
        Public Gp0in As Short
        Public Gp1in As Short
        Public Exp0in As Short
        Public Exp1in As Short
        Public Ctlp0in As Short
    End Structure

    '*** OUT PORT STRUCTURE ***
    Structure MC07_S_OUT_PORT
        Public Gpout As Short
        Public Gp0out As Short
        Public Gp1out As Short
        Public Exp0out As Short
        Public Exp1out As Short
        Public Ctlp0out As Short
    End Structure

    '*** UNIT STATUS STRUCTURE ***
    Structure MC07_S_UNIT_STATUS
        Public X As MC07_S_STATUS_DATA
        Public Y As MC07_S_STATUS_DATA
        Public Z As MC07_S_STATUS_DATA
        Public A As MC07_S_STATUS_DATA
        Public InPort As MC07_S_IN_PORT
    End Structure

    '*** UNIT COMMAND STRUCTURE ***
    Structure MC07_S_UNIT_COMMAND
        Public X As MC07_S_COMMAND_DATA
        Public Y As MC07_S_COMMAND_DATA
        Public Z As MC07_S_COMMAND_DATA
        Public A As MC07_S_COMMAND_DATA
        Public OutPort As MC07_S_OUT_PORT
    End Structure

    '*** MPL Function Declarations ***
    Declare Function MC07_Environment Lib "Mc07UsbC.dll" (ByVal UnitNo As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadUnitInfo Lib "Mc07UsbC.dll" (ByVal UnitNo As Short, ByRef psUnitInfo As MC07_S_UNIT_INFO, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UOpen Lib "Mc07UsbC.dll" (ByVal UnitNo As Short, ByRef phUnit As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UClose Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UClrError Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWExUnitCommMode Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal CommRate As Short, ByVal RetryCount As Short, ByVal IoBit As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWExUnitCommControl Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal ControlSel As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URExUnitCommStatus Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URExUnitCommMode Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByRef pCommRate As Short, ByRef pRetryCount As Short, ByRef pIoBit As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRADData Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal Signal As Short, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IRADData Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByRef psData As MC07_S_AD_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWDriveIo Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal IoPortSel As Integer, ByRef psUnitCmd As MC07_S_UNIT_COMMAND, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UWRDrive Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByRef psUnitCmd As MC07_S_UNIT_COMMAND, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URStatus1Io Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal IoPortSel As Integer, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_URStatus1PcntIo Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal AxisSel As Integer, ByVal IoPortSel As Integer, ByRef psUnitStatus As MC07_S_UNIT_STATUS, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortOut Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortOrOut Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortAndOut Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psOutPort As MC07_S_OUT_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_UPortIn Lib "Mc07UsbC.dll" (ByVal hUnit As Integer, ByVal IoPortSel As Integer, ByRef psInPort As MC07_S_IN_PORT, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BOpen Lib "Mc07UsbC.dll" (ByVal UnitNo As Short, ByVal Axis As Short, ByRef phDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BClose Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ClrError Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BufWDrive Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psCmdBuf As MC07_S_COMMAND_BUF, ByRef psDataBuf As MC07_S_DATA_BUF, ByVal Count As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWDrive Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWData Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWDrive Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IWData Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWDriveBuf Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal CmdDataBuf() As MC07_S_COMMAND_DATA, ByVal Count As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveCommand Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pCmd As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveData1 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWDriveData2 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_AllRStatus Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psStsBuf As MC07_S_STATUS_BUF, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus1 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus2 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus3 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus4 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatus5 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRStatusBuf Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal StatusBuf() As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LRDrive Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IRDrive Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psData As MC07_S_DATA, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRDriveData1 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BRDriveData2 Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_LWRDrive Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal Cmd As Short, ByRef pWriteData As Integer, ByRef pReadData As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWaitDriveCommand Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BWaitComregNotFull Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal WaitTime As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BIsWait Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pWaitSts As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BBreakWait Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetSpeedRate Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal ResolNo As Short, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadSpeedRate Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pResolNo As Short, ByRef psSpeedRate As MC07_S_SPEED_RATE, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_McIncStrCp Lib "Mc07UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_McIncCirCp Lib "Mc07UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByVal DrvSpec As Short, ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_GetCirShortPulse Lib "Mc07UsbC.dll" (ByVal Dir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pShortPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_GetCirCenterPosition Lib "Mc07UsbC.dll" (ByRef psPassPosition As MC07_S_XY_POSITION, ByRef psTargetPosition As MC07_S_XY_POSITION, ByRef pDir As Short, ByRef psCenterPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_IncFromAbs Lib "Mc07UsbC.dll" (ByVal hDevX As Integer, ByVal hDevY As Integer, ByRef psAbsPosition As MC07_S_XY_POSITION, ByRef psIncPosition As MC07_S_XY_POSITION, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadOrgStatus Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef pStatus As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgSpec Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal Spec As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgMarginPulse Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal MarginPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgDelay Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal LimitDelay As Short, ByVal ScanDelay As Short, ByVal PulseDelay As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgErrorPulse Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal CScanErrorPulse As Integer, ByVal PulseErrorPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgOffsetPulse Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal OffsetPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_SetOrgPresetPulse Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal PresetPulse As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ReadOrgParam Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psOrgParam As MC07_S_ORG_PARAM, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_ResetOrgFlag Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_Org Lib "Mc07UsbC.dll" (ByVal hDev As Integer, ByVal OrgType As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Sub MC07_SetData Lib "Mc07UsbC.dll" (ByVal Data As Integer, ByRef psData As MC07_S_DATA)
    Declare Function MC07_GetData Lib "Mc07UsbC.dll" (ByRef psData As MC07_S_DATA) As Integer
    Declare Function MC07_BPortOpen Lib "Mc07UsbC.dll" (ByVal UnitNo As Short, ByVal IoPort As Short, ByRef phPort As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortClose Lib "Mc07UsbC.dll" (ByVal hPort As Integer, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortOut Lib "Mc07UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortOrOut Lib "Mc07UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortAndOut Lib "Mc07UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_BPortIn Lib "Mc07UsbC.dll" (ByVal hPort As Integer, ByRef pData As Short, ByRef psResult As MC07_S_RESULT) As Boolean
    Declare Function MC07_Unsigned16 Lib "Mc07UsbC.dll" (ByVal Data As Short) As UShort
    Declare Function MC07_Signed16 Lib "Mc07UsbC.dll" (ByVal Data As UShort) As Short
    Declare Function MC07_Unsigned32 Lib "Mc07UsbC.dll" (ByVal Data As Integer) As UInteger
    Declare Function MC07_Signed32 Lib "Mc07UsbC.dll" (ByVal Data As UInteger) As Integer
End Module
